#import <Foundation/Foundation.h>
#import <Foundation/NSAutoreleasePool.h>
#import <stdio.h>
#import "Dog.h"
#import "DogExt.h"

int main( int argc, const char *argv[] ) {
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	Dog *dog = [[Dog alloc] init ];
	[dog setName : @"Buddy"];
	[dog Wow];
	
	int dog_feet = [dog FeetNumber];	//通过成员调用类方法
	printf("There is %d feet of Dog!\r\n",dog_feet);
	
	
	id dog2 = [[Dog alloc] init ];
	[dog2 setName : @"Tom"];				//有method就反应,没有就不反应
	[dog2 Wow];
	
	dog->public_var = 2;							//测试成员变量存取权限
	//dog->protected_var = 5;
	
	//dynamic types
	if( [dog isMemberOfClass : [Animal class]] == YES )
	{
		printf("dog is a member Animal\r\n");
	}
	else
	{
		printf("dog is not a member Animal\r\n");
	}
	
	if( [dog isKindOfClass : [Animal class]] == YES )
	{
		printf("dog is kind of Animal\r\n");
	}
	else
	{
		printf("dog is not kind of Animal\r\n");
	}
	
	if([dog respondsToSelector : @selector(Wow) ] == YES)
	{
		printf("dog respondsToSelector 'Wow' and performs it\r\n");
		[dog performSelector : @selector(Wow)];
	}
	else
	{
		printf("dog not respondsToSelector 'Wow' \r\n");
	}
	
	if([Dog instancesRespondToSelector : @selector(printDogCount) ] == YES)
	{
		printf("Dog instancesRespondToSelector 'printDogCount' \r\n");
	}
	else
	{
		printf("Dog not instancesRespondToSelector 'printDogCount' \r\n");
	}
    [Dog performSelector : @selector(printDogCount)];
	
	//Categories
	[dog PlayBall];
	
	//protocol
	id <Print> id_print = dog;
	[id_print Print];
	if( [dog conformsToProtocol : @protocol(Print)] == YES)
	{
		printf("dog conformsToProtocol Print\r\n");
	}
	
	
	//Memory
	Dog *dog3 = [[Dog alloc] init];
	printf("dog3 retain count=%d\r\n",(int)[dog3 retainCount]);
	Dog *ref1 = [dog3 retain];
	printf("dog3 retain count=%d\r\n",(int)[dog3 retainCount]);
	Dog *ref2 = [dog3 retain];
	printf("dog3 retain count=%d\r\n",(int)[dog3 retainCount]);
	
	[dog3 release];
	printf("dog3 retain count=%d\r\n",(int)[dog3 retainCount]);
	[ref1 release];
	printf("dog3 retain count=%d\r\n",(int)[dog3 retainCount]);
	[ref2 release];
	
	
	[dog release];
	[dog2 release];
	[pool release];
}